package com.ippon.article.clientmobile;

import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListView;

import com.couchbase.lite.CouchbaseLiteException;
import com.couchbase.lite.Database;
import com.couchbase.lite.Result;
import com.ippon.article.clientmobile.database.CouchbaseLite;

import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class ArticleActivity extends AppCompatActivity {

    private final static String TAG = "ArticleApp";

    private final static String GATEWAY_URL = "ws://10.0.2.2:4984/";

    private final static String GATEWAY_DB = "app";

    private final static String GATEWAY_USER = "test";

    private final static String GATEWAY_PWD = "test";

    private Database database;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_article);
    }

    @Override
    protected void onStart() {
        super.onStart();
        // Init & Configure database
        try {
            database = CouchbaseLite.openDatabase(this.getApplicationContext());

            //CouchbaseLite.createDocument(database);

            CouchbaseLite.configureReplication(database, GATEWAY_URL + GATEWAY_DB, GATEWAY_USER, GATEWAY_PWD);

        } catch (CouchbaseLiteException e) {
            Log.e(TAG, "Application startup", e);
        } catch (URISyntaxException uri) {
            Log.e(TAG, "Gateway URL syntax problem", uri);
        }


        Button clickButton = (Button) findViewById(R.id.refresh);
        clickButton.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                List<Result> results = Collections.emptyList();

                try {
                    results = CouchbaseLite.findAllDocuments(database, "com.ippon.article.couchbase.server.article.Article");
                } catch (CouchbaseLiteException e) {
                    Log.e(TAG, "Refresh documents from database", e);
                }

                Log.i(TAG, "----------RESULTS---------" + results.size());
                List<String> items = new ArrayList<>();

                for (Result result : results) {
                    Log.i(TAG, "------------------------");
                    if (result.getString("content") != null) {
                        Log.i(TAG, result.getString("content"));
                        items.add(result.getString("content"));
                    }

                }

                fillArticles(items);
            }
        });

    }

    private void fillArticles(List<String> items) {
        ListView articleView = (ListView) findViewById(R.id.articles);
        ArrayAdapter<String> itemsAdapter =
                new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, items);
        articleView.setAdapter(itemsAdapter);
    }


}
